% Lezione di lab. 3 TTR  -19/04/2011- Tracking by Condensation- Marco Cristani

clear all;
clc;

%----------------------
% INIZIALIZZAZIONI
%----------------------

N       = 50 ; % numero particelle;
n_it    = 20   ; % iterazioni (= frames) del tracking;
loc_w   = 2   ; % larghezza della finestra d'osservazione;
dvst    = loc_w/3; % dev. standard per l'osservazione;

%% -- PARAMETRI MOTO -- %%
step        = 0.4  ;   
p_noise     = 0.075 ;  


%% -- PARAMETRI MOTO -- %%
diffu = 2; 
%% -- PRIMO SAMPLING -- %%
real_pos               = 0.0;

for n=1:N
   s_old(n)                 =  unifrnd(real_pos-3,real_pos+3) ;
end;  
pi = ones(1,N)./N;
c = cumsum(pi);
C  = 1;


 h = figure;
%----------------------
% CICLO PRINCIPALE
%----------------------
%% -- EVOLUZIONE SISTEMA -- %%
for i=1:n_it
    real_pos    =   real_pos + step + p_noise * randn(1,1);
    x(i)        =   real_pos;
    fprintf('t=%i|true pos. %2.2f \n',i,x(i));
    sit(i).oneD =  [x(i),...
        unifrnd(real_pos-10,real_pos+10,1,round(unifrnd(1,5))),...
        normrnd(real_pos,0.01,1,3)];
%% -- ESTRAZIONE E APPLICAZIONE DINAMICA -- %%
 for n=1:N
      ind     = pick_base_sample(C,N,c);
      s(n)     = s_old(ind) + step + diffu * randn(1,1);
 end   

 scatter(i,real_pos,500,[1 0 0],'Marker','x');hold on 
 scatter(ones(1,size(sit(i).oneD,2)).*i,sit(i).oneD,10,[1 0 0],'Marker','o');
 
 for n=1:N
     mpi(n) = 0;
     for j =1:size(sit(i).oneD,2)
         if s(n)+loc_w>sit(i).oneD(j) & s(n)-loc_w<sit(i).oneD(j)
            mpi(n)= mpi(n)+normpdf(sit(i).oneD(j),s(n),dvst);
         end
     end
 end   
 s_old = s;
 mpi = normalise(mpi);
 c = cumsum(mpi);
 
 scatter(ones(1,N).*i,s,1000.*mpi+1);
 pause;
end



% Esercizi:
% 1) Stimate l'obiettivo individuato dal tracker ad ogni iterazione,
% mediante le due politiche viste a lezione. Visualizzate a schermo le
% stime ottenute. Calcolate l'errore (lineare) ottenuto.
% 2) Cambiate la dinamica della particella a piacere, osservate come
%    reagisce il tracker.
% 3) Aumentate/diminuite il numero dele particelle
% 4) Aumentate il numero delle presenze di rumore
% 5) Aggiungete un'altra particella con moto determinato




